Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mindswap.pellet.tbox.impl
Class TBoxExpImpl

    java.lang.Object
      org.mindswap.pellet.tbox.impl.TBoxExpImpl

All Implemented Interfaces:
  TBox

    public class TBoxExpImpl

extends java.lang.Object
implements TBox

Title: Implementation of TBox interface to generate explanations efficiently and correctly.

Description:

Copyright: Copyright (c) 2007

Company: Clark & Parsia, LLC.

Author:
  Evren Sirin

Field Summary
`static org.apache.commons.logging.Log` | `log`
`TgBox` | `Tg`
`TuBox` | `Tu`

Constructor Summary
`TBoxExpImpl(KnowledgeBase kb)`

Method Summary
`void` | `absorb()` Absorb GCIs into primitive definitions
`boolean` | `addAxiom(aterm.ATermAppl axiom, java.util.Set<aterm.ATermAppl> explain)` Add a new sub or equivalent class axiom with the given explanation.
`boolean` | `addAxiom(aterm.ATermAppl axiom, java.util.Set<aterm.ATermAppl> explain, boolean forceAddition)`
`boolean` | `addAxiomExplanation(aterm.ATermAppl axiom, java.util.Set<aterm.ATermAppl> explain)` Add a new explanation for the given axiom.
`boolean` | `addClass(aterm.ATermAppl term)` Add a named class declaration
`boolean` | `containsAxiom(aterm.ATermAppl axiom)`
`java.util.Set<aterm.ATermAppl>` | `getAllClasses()` Return all the named classes plus TOP and BOTTOM
`java.util.Set<aterm.ATermAppl>` | `getAxiomExplanation(aterm.ATermAppl axiom)` Return a single explanation for the given TBox axiom.
`java.util.Set<java.util.Set<aterm.ATermAppl>>` | `getAxiomExplanations(aterm.ATermAppl axiom)` Return multiple explanations for the given TBox axiom.
`java.util.Collection<aterm.ATermAppl>` | `getAxioms()` Return all the axioms defined in this TBox
`java.util.Collection<aterm.ATermAppl>` | `getAxioms(aterm.ATermAppl term)` Return all the sub and equivalent class axioms that have the given concept on the left hand side
`java.util.Set<aterm.ATermAppl>` | `getClasses()` Return all the named classes
`java.util.List<Pair<aterm.ATermAppl,java.util.Set<aterm.ATermAppl>>>` | `getUC()` Return the universal concept
`void` | `internalize()` Turn the non-absorbed GCIs into disjunctions that will be used in the universal concept
`void` | `normalize()` Normalize the primitive definitions so they can be directly used in unfolding
`boolean` | `removeAxiom(aterm.ATermAppl axiom)` Remove the axiom from TBox and all other axioms that depend on it.
`void` | `split()`
`java.lang.String` | `toString()`
`java.util.List<Pair<aterm.ATermAppl,java.util.Set<aterm.ATermAppl>>>` | `unfold(aterm.ATermAppl c)` Lazy unfold the given concept

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### log

    public static org.apache.commons.logging.Log log

### Tu

    public TuBox Tu

### Tg

    public TgBox Tg

Constructor Detail

### TBoxExpImpl

    public TBoxExpImpl(KnowledgeBase kb)

Method Detail

### getAllClasses

    public java.util.Set<aterm.ATermAppl> getAllClasses()

  Description copied from interface: `TBox`
  Return all the named classes plus TOP and BOTTOM

  Specified by:
    `getAllClasses` in interface `TBox`

### getAxiomExplanations

    public java.util.Set<java.util.Set<aterm.ATermAppl>> getAxiomExplanations(aterm.ATermAppl axiom)

  Description copied from interface: `TBox`
  Return multiple explanations for the given TBox axiom.

  Specified by:
    `getAxiomExplanations` in interface `TBox`
  Returns:

### getAxiomExplanation

    public java.util.Set<aterm.ATermAppl> getAxiomExplanation(aterm.ATermAppl axiom)

  Description copied from interface: `TBox`
  Return a single explanation for the given TBox axiom.

  Specified by:
    `getAxiomExplanation` in interface `TBox`
  Returns:

### addAxiomExplanation

    public boolean addAxiomExplanation(aterm.ATermAppl axiom,
                                       java.util.Set<aterm.ATermAppl> explain)

  Description copied from interface: `TBox`
  Add a new explanation for the given axiom. If a previous explanation exists this will be stored as another explanation.

  Specified by:
    `addAxiomExplanation` in interface `TBox`
  Returns:

### addAxiom

    public boolean addAxiom(aterm.ATermAppl axiom,
                            java.util.Set<aterm.ATermAppl> explain)

  Description copied from interface: `TBox`
  Add a new sub or equivalent class axiom with the given explanation. The explanation is the syntactic axiom(s) used in the ontology. For example, a disjoint axiom is turned into a subclass axiom so the explanation for sub(a,not(b)) will be disjoint(a,b). Explanation should be a minimal set of axioms for the overall explanation to come out correct.

  Specified by:
    `addAxiom` in interface `TBox`
  Returns:

### addAxiom

    public boolean addAxiom(aterm.ATermAppl axiom,
                            java.util.Set<aterm.ATermAppl> explain,
                            boolean forceAddition)

### removeAxiom

    public boolean removeAxiom(aterm.ATermAppl axiom)

  Description copied from interface: `TBox`
  Remove the axiom from TBox and all other axioms that depend on it. An axiom depends on another axiom if it is a syntactic transformation (as in disjoint axiom is transformed into subclass) or it is obtained via absorption (as equivalent class axioms are absorbed into subclass axioms)

  Specified by:
    `removeAxiom` in interface `TBox`
  Returns:

### getAxioms

    public java.util.Collection<aterm.ATermAppl> getAxioms()

  Description copied from interface: `TBox`
  Return all the axioms defined in this TBox

  Specified by:
    `getAxioms` in interface `TBox`

### containsAxiom

    public boolean containsAxiom(aterm.ATermAppl axiom)

### split

    public void split()

  Specified by:
    `split` in interface `TBox`

### absorb

    public void absorb()

  Description copied from interface: `TBox`
  Absorb GCIs into primitive definitions

  Specified by:
    `absorb` in interface `TBox`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### getUC

    public java.util.List<Pair<aterm.ATermAppl,java.util.Set<aterm.ATermAppl>>> getUC()

  Description copied from interface: `TBox`
  Return the universal concept

  Specified by:
    `getUC` in interface `TBox`
  Returns:
    Returns the UC.

### addClass

    public boolean addClass(aterm.ATermAppl term)

  Description copied from interface: `TBox`
  Add a named class declaration

  Specified by:
    `addClass` in interface `TBox`
  Returns:
    `true` if TBox changed as a result of this call

### getClasses

    public java.util.Set<aterm.ATermAppl> getClasses()

  Description copied from interface: `TBox`
  Return all the named classes

  Specified by:
    `getClasses` in interface `TBox`

### getAxioms

    public java.util.Collection<aterm.ATermAppl> getAxioms(aterm.ATermAppl term)

  Description copied from interface: `TBox`
  Return all the sub and equivalent class axioms that have the given concept on the left hand side

  Specified by:
    `getAxioms` in interface `TBox`

### normalize

    public void normalize()

  Description copied from interface: `TBox`
  Normalize the primitive definitions so they can be directly used in unfolding

  Specified by:
    `normalize` in interface `TBox`

### internalize

    public void internalize()

  Description copied from interface: `TBox`
  Turn the non-absorbed GCIs into disjunctions that will be used in the universal concept

  Specified by:
    `internalize` in interface `TBox`

### unfold

    public java.util.List<Pair<aterm.ATermAppl,java.util.Set<aterm.ATermAppl>>> unfold(aterm.ATermAppl c)

  Description copied from interface: `TBox`
  Lazy unfold the given concept

  Specified by:
    `unfold` in interface `TBox`
  Returns:

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Evren Sirin. All Rights Reserved.